<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1" />
  <title></title>
  <style>
    table.dataTable tbody td {
      word-break: break-word;
      vertical-align: top;
    }
  </style>
  <link rel="stylesheet"
    href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback" />

  <!-- Font Awesome -->
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.2/css/all.min.css"
    integrity="sha512-z3gLpd7yknf1YoNbCzqRKc4qyor8gaKU1qmn+CShxbuBusANI9QpRohGBreCFkKxLhei6S9CQXFEbbKuqLg0DA=="
    crossorigin="anonymous" referrerpolicy="no-referrer" />

  <!-- DataTables -->
  <link rel="stylesheet" href="plugins/datatables-bs4/css/dataTables.bootstrap4.min.css" />

  <!-- Toastr -->
  <link rel="stylesheet" href="plugins/toastr/toastr.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
</head>

<body class="hold-transition sidebar-mini">
  <div class="wrapper">
    <!-- Navbar -->
    <nav class="main-header navbar navbar-expand navbar-white navbar-light" id="header-navbar">
    </nav>
    <!-- /.navbar -->

    <!-- Main Sidebar Container -->
    <aside class="main-sidebar sidebar-dark-primary elevation-4">
      <!-- Brand Logo -->
      <a href="#" class="brand-link">
        <span class="brand-text font-weight-light" style="margin-left:10px">SHOP</span>
      </a>

      <!-- Sidebar -->
      <div class="sidebar">
        <!-- Sidebar user (optional) -->
        <div class="user-panel mt-3 pb-3 mb-3 d-flex">
          <div class="image">
            <img src="dist/img/female.jpg" class="img-circle elevation-2" alt="User Image" />
          </div>
          <div class="info">
            <a id="leftside-username" href="#" class="d-block"></a>
          </div>
        </div>

        <!-- SidebarSearch Form -->
        <div class="form-inline">
          <div class="input-group" data-widget="sidebar-search">
            <input class="form-control form-control-sidebar" type="search" placeholder="Search" aria-label="Search" />
            <div class="input-group-append">
              <button class="btn btn-sidebar">
                <i class="fas fa-search fa-fw"></i>
              </button>
            </div>
          </div>
        </div>

        <!-- Sidebar Menu -->
        <nav class="mt-2" id="sidebar-menu">

        </nav>
        <!-- /.sidebar-menu -->
      </div>
      <!-- /.sidebar -->
    </aside>

    <!-- Content Wrapper. Contains page content -->
    <div class="content-wrapper">
      <!-- Content Header (Page header) -->
      <section class="content-header">
        <div class="container-fluid">
          <div class="row mb-2">
            <div class="col-sm-6">
              <h1></h1>
            </div>
            <div class="col-sm-6">
              <ol class="breadcrumb float-sm-right">
                <li class="breadcrumb-item"><a href="#">Home</a></li>
                <li class="breadcrumb-item active">Product Line</li>
              </ol>
            </div>
          </div>
        </div>
        <!-- /.container-fluid -->
      </section>

      <!-- Main content -->
      <section class="content">
        <div class="container-fluid">
          <div class="row">
            <div class="col-md-12">
              <div class="card card-primary">
                <div class="card-header">
                  <div class="row">
                    <div class="col-sm-6 d-flex align-middle">
                      <h3 class="card-title align-middle recss-card-title"
                        style="margin-bottom: 0; align-self: center; text-transform: uppercase;"></h3>
                    </div>
                    <div class="col-sm-6 text-right">
                      <button data-action="create" class="btn btn-success">
                        + Create
                      </button>
                    </div>
                  </div>
                </div>
              </div>

              <table class="table table-bordered table-striped table-hover" id="table">
                <tfoot>
                  <tr>
                    <th></th>
                    <th></th>
                    <th></th>
                    <th></th>
                  </tr>
                </tfoot>
              </table>
            </div>
          </div>
        </div>

        <!-- MODAL CREATE/UPDATE -->
        <div id="modal-edit" class="modal" tabindex="-1">
          <div class="modal-dialog modal-lg">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <div class="form-group" id="div-id">
                  <label for="input-id">ID</label>
                  <input id="input-id" name="id" class="form-control" type="text" disabled />
                  <div class="invalid-feedback"></div>
                </div>
                <div class="form-group">
                  <label for="input-name">Name<span class="text-danger"> *</span></label>
                  <input id="input-name" name="name" class="form-control" type="text"
                    placeholder="Enter product name" />
                  <div class="invalid-feedback"></div>
                </div>

                <div id="div-type" class="form-group">
                  <label for="select-type">Type <span class="text-danger">*</span></label>
                  <select class="form-control" name="type" id="select-type">
                    <option selected disabled value="">Choose type</option>
                    <option value="category">Category</option>
                    <option value="brand">Brand</option>
                    <option value="color">Color</option>
                  </select>
                  <div class="invalid-feedback"></div>
                </div>
                <div class="modal-footer">
                  <button id="button-update" type="button" class="btn btn-primary">
                    Edit
                  </button>
                  <button id="button-create" type="button" class="btn btn-primary">
                    Create
                  </button>
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">
                    Cancel
                  </button>
                </div>
              </div>
            </div>
          </div>
        </div>
        <!-- MODAL DELETE -->
        <div id="modal-delete" class="modal" tabindex="-1" role="dialog">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <p></p>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Cancel
                </button>
                <button type="button" class="btn btn-danger" id="button-delete">
                  Sure
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- MODAL APPROVE -->
        <div id="modal-approve" class="modal" tabindex="-1" role="dialog">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <p></p>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Cancel
                </button>
                <button type="button" class="btn btn-success" id="button-approve">
                  Sure
                </button>
              </div>
            </div>
          </div>
        </div>

        <!-- MODAL REJECT -->
        <div id="modal-reject" class="modal" tabindex="-1" role="dialog">
          <div class="modal-dialog" role="document">
            <div class="modal-content">
              <div class="modal-header">
                <h5 class="modal-title"></h5>
                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                  <span aria-hidden="true">&times;</span>
                </button>
              </div>
              <div class="modal-body">
                <p></p>
              </div>
              <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-dismiss="modal">
                  Cancel
                </button>
                <button type="button" class="btn btn-danger" id="button-reject">
                  Sure
                </button>
              </div>
            </div>
          </div>
        </div>


      </section>
      <!-- /.content -->
    </div>
    <!-- /.content-wrapper -->
    <footer class="main-footer">
      <div class="float-right d-none d-sm-block"><b>Version</b> 3.2.0</div>
      <strong>Copyright &copy; 2023
        <a href="https://bery.io">Bery</a>.</strong>
      All rights reserved.
    </footer>

    <!-- Control Sidebar -->
    <aside class="control-sidebar control-sidebar-dark">
      <!-- Control sidebar content goes here -->
    </aside>
    <!-- /.control-sidebar -->
  </div>
  <!-- ./wrapper -->
  <!-- <script src="sidebar-menu.js"></script>
  <script src="header.js"></script>
  <script src="ajax.js"></script> -->
  <!-- <script src="toastr.min.js"></script> -->

  <!-- jQuery -->
  <script src="plugins/jquery/jquery.min.js"></script>
  <!-- Bootstrap 4 -->
  <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
  <!--Datatables -->
  <script src="plugins/datatables/jquery.dataTables.min.js"></script>
  <script src="plugins/datatables-bs4/js/dataTables.bootstrap4.min.js"></script>
  <script src="plugins/datatables-responsive/js/dataTables.responsive.min.js"></script>
  <script src="plugins/datatables-responsive/js/responsive.bootstrap4.min.js"></script>
  <!-- Toastr -->
  <script src="plugins/toastr/toastr.min.js"></script>
  <!-- AdminLTE App -->
  <script src="dist/js/adminlte.min.js"></script>
  <!-- ./wrapper -->

  <script src="sidebar-menu.js"></script>
  <script src="header.js"></script>
  <script src="ajax.js"></script>
  <script src="location.js"></script>

  <!-- Page specific script -->
  <script>
    let gSelectedID = 0;
    const formatReadableDate = (dateString) => new Date(dateString).toLocaleDateString('en-GB', { timeZone: 'UTC' });
    function renderTable() {
      const table = $('#table').DataTable({
        paging: false,
        scrollCollapse: true,
        scrollX: true,
        scrollY: 300,
        autoWidth: false,
        columns: [
          { data: 'id' },
          { data: 'id', title: 'ID' },
          { data: 'type', title: 'Type' },
          { data: 'name', title: 'Name' },
        ],
        columnDefs: [
          {
            targets: 0,
            render: (data) => `
                    <div class="d-flex">
                      <button data-id=${data} data-action="edit" class="btn btn-lg" data-toggle="tooltip" title="Edit"><i class="fas fa-edit"></i></button>
                      <button data-id=${data} data-action="delete" class="btn btn-lg" data-toggle="tooltip" title="Delete"><i class="fas fa-trash-alt"></i></button>
                    </div>
            `,
          },
        ],
        language: {
          url: 'https://cdn.datatables.net/plug-ins/1.13.6/i18n/vi.json',
        },
      });

      return table;
    }


    // Hiển thị data lên modal
    function displayDataOnInput(pObj) {
      $('#input-id').val(pObj.id);
      $('#input-name').val(pObj.name);
      $('#select-type').val(pObj.type);
    }

    // Đọc data trên modal
    function readData() {
      const objData = {
        name: null,
        type: null,
      };

      objData.type = $('#select-type').val();
      objData.name = $('#input-name').val();
      return objData;
    }

    // Xóa toàn bộ dữ liệu trên modal
    function clearData() {
      $('#input-name').val('');
      $('#select-type').val('');
      $('.form-control').removeClass('is-invalid');
    }

    // Hàm kiểm tra dữ liệu
    function checkData(pObjData) {
      let isValid = true;
      $('.is-invalid').removeClass('is-invalid');

      if (pObjData.name === '') {
        $('#input-name').addClass('is-invalid');
        $('#input-name ~ .invalid-feedback').text('Please enter name');
        isValid = false;
      }

      if (pObjData.type === null) {
        $('#select-type').addClass('is-invalid');
        $('#select-type ~ .invalid-feedback').text('Please select type');
        isValid = false;
      }

      return isValid;
    }

    // Gán sự kiện cho nút create trên table
    $('button[data-action="create"]').on('click', () => {
      $('#modal-edit').modal('show');
      $('#modal-edit .modal-title').text('CREATE PRODUCT');
      $('#button-update').hide();
      $('#button-create').show();
      $('#div-id').hide();

      clearData();
    });

    // Gán sự kiện cho nút create trên modal
    $('#button-create').on('click', () => {
      // Đọc dữ liệu trên form
      const objData = readData();

      // Kiểm tra dữ liệu
      const isValidated = checkData(objData);

      if (isValidated) {
        // Gọi Api tạo mới data
        $.ajax({
          url: 'http://localhost:8090/product-line/',
          type: 'POST',
          contentType: 'application/json',
          data: JSON.stringify(objData),
          success: () => {
            $('#modal-edit').modal('hide');
            $(document).Toasts('create', {
              class: 'bg-success',
              title: 'Success',
              subtitle: '',
              body: 'Create data successful.',
              autohide: true,
              delay: 850,
            })
          },
          error: () => {
            $('#modal-edit').modal('hide');
            $(document).Toasts('create', {
              class: 'bg-danger',
              title: 'Error',
              subtitle: '',
              body: 'Create data not successful.',
              autohide: true,
              delay: 850,
            })
          },
        });
      }
    });

    // Gán sự kiện cho nút edit trên table
    $('#table').on('click', 'button[data-action="edit"]', (event) => {
      gSelectedID = event.currentTarget.dataset.id;
      $('#modal-edit').modal('show');
      $('#modal-edit .modal-title').text('EDIT PRODUCT');
      $('#button-create').hide();
      $('#button-update').show();
      $('#div-id').show();

      clearData();

      // Gọi API lấy dữ liệu address map theo Id
      $.ajax({
        url: `http://localhost:8090/product-line/${gSelectedID}`,
        type: 'GET',
        dataType: 'json',
        success: (res) => {
          displayDataOnInput(res);
        },
      });
    });

    // Gán sự kiện cho nút edit trên modal
    $('#button-update').on('click', () => {
      // Đọc dữ liệu trên modal
      const objData = readData();

      // Kiểm tra dữ liệu
      const isValidated = checkData(objData);
      if (isValidated) {
        // Gọi Api update data
        $.ajax({
          url: `http://localhost:8090/product-line/${gSelectedID}`,
          type: 'PUT',
          contentType: 'application/json',
          data: JSON.stringify(objData),
          success: () => {
            $('#modal-edit').modal('hide');
            $(document).Toasts('create', {
              class: 'bg-success',
              title: 'Success',
              subtitle: '',
              body: 'Edit data successful.',
              autohide: true,
              delay: 850,
            })
          },
          error: () => {
            $('#modal-edit').modal('hide');
            $(document).Toasts('create', {
              class: 'bg-danger',
              title: 'Error',
              subtitle: '',
              body: 'Edit data not successful.',
              autohide: true,
              delay: 850,
            })
          },
        });
      }
    });

    // Gán sự kiện cho nút delete trên table
    $('#table').on('click', 'button[data-action="delete"]', (event) => {
      gSelectedID = event.currentTarget.dataset.id;
      $('#modal-delete').modal('show');
      $('#modal-delete .modal-title').text('DELETE PRODUCT');
      $('#modal-delete .modal-body p').text('Are you sure you want to delete this productLine?');
    });

    // Gán sự kiện cho nút delete trên modal
    $('#button-delete').on('click', () => {
      // Gọi Api delete data
      $.ajax({
        url: `http://localhost:8090/product-line/${gSelectedID}`,
        type: 'DELETE',
        success: () => {
          $('#modal-delete').modal('hide');
          $(document).Toasts('create', {
            class: 'bg-success',
            title: 'Success',
            subtitle: '',
            body: 'Edit data successful.',
            autohide: true,
            delay: 850,
          })
        },
        error: () => {
          $('#modal-delete').modal('hide');
          $(document).Toasts('create', {
            class: 'bg-danger',
            title: 'Error',
            subtitle: '',
            body: 'Create data not successful.',
            autohide: true,
            delay: 850,
          })
        },
      });
    });

    // Gán sự kiện cho nút reject trên modal
    $('#button-reject').on('click', () => {
      // Gọi Api reject data
      $.ajax({
        url: `http://localhost:8090/product-line/${gSelectedID}/2`,
        type: 'PUT',
        success: () => {
          alert('Update data successful');
          window.location.reload();
        },
        error: () => {
          alert('Update data not successful');
        },
      });
    });

    $(document).ready(() => {
      document.title = 'Product Line Management';
      $('.recss-card-title').text(document.title);

      const vUsername = localStorage.getItem('username');
      $('#username').text(`${vUsername}`);
      $('#leftside-username').text(`${vUsername}`);

      $('#input-sellPrice').keyup(function (event) {
        // skip for arrow keys
        if (event.which >= 37 && event.which <= 40) return;

        // format number
        $(this).val(function (index, value) {
          return value
            .replace(/\D/g, '')
            .replace(/\B(?=(\d{3})+(?!\d))/g, '.');
        });
      });

      $('#input-originalPrice').keyup(function (event) {
        // skip for arrow keys
        if (event.which >= 37 && event.which <= 40) return;

        // format number
        $(this).val(function (index, value) {
          return value
            .replace(/\D/g, '')
            .replace(/\B(?=(\d{3})+(?!\d))/g, '.');
        });
      });

      $('#input-quantityInStock').keyup(function (event) {
        // skip for arrow keys
        if (event.which >= 37 && event.which <= 40) return;

        // format number
        $(this).val(function (index, value) {
          return value
            .replace(/\D/g, '')
            .replace(/\B(?=(\d{3})+(?!\d))/g, '.');
        });
      });


      $.ajax({
        url: 'http://localhost:8090/product-line/',
        type: 'GET',
        dataType: 'json',
        success: (res) => {
          const table = renderTable();
          table.clear();
          table.rows.add(res);
          table.draw();
        },
      });
    });
  </script>
</body>

</html>